package me.ntfwc.blockLoggingPlugin;


import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.event.Listener;
import org.bukkit.event.EventHandler;
import org.bukkit.block.Block;
import org.bukkit.block.BlockState;
import org.bukkit.entity.Player;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;

public class BlockListener implements Listener {
	
	private void recordBlockChange(String username, Location location, int block_id1, byte block_data1, int block_id2, byte block_data2)
	{
		String worldName = CoreAPI.getWorldName(location);
		int x = CoreAPI.getX(location);
		int y = CoreAPI.getY(location);
		int z = CoreAPI.getZ(location);
		
		LoggableBlockChange blockChange = new LoggableBlockChange(x, y, z, username, worldName, block_id1, block_data1, block_id2, block_data2, System.currentTimeMillis());
		
		LoggingTask_StoreBlockChange task = new LoggingTask_StoreBlockChange(blockChange);
		CoreAPI.blockLoggingRunnable.enqueTask(task);
	}
	
    @EventHandler
    public void onBlockPlace(BlockPlaceEvent event){
    	Player player = event.getPlayer();
    	Block block = event.getBlock();
    	PlayerDataContainer playerDataContainer = CoreAPI.getPlayerDataContainer(player);
    	playerDataContainer.addBlockChange(block);
    	
    	//for the block database
    	String username = CoreAPI.getPlayerName(player);
    	BlockState priorBlockState = event.getBlockReplacedState();
    	Block newBlock = event.getBlockPlaced();
    	Location location = CoreAPI.getBlockLocation(newBlock);
    	int block_id1 = priorBlockState.getTypeId();
    	byte block_data1 = priorBlockState.getRawData();
    	int block_id2 = CoreAPI.getBlockType(newBlock).getId();
    	byte block_data2 = CoreAPI.getBlockData(newBlock);
    	recordBlockChange(username, location, block_id1, block_data1, block_id2, block_data2);
    }
    
    @EventHandler
    public void onBlockBreak(BlockBreakEvent event) 
    {
    	Player player = event.getPlayer();
    	Block block = event.getBlock();
    	PlayerDataContainer playerDataContainer = CoreAPI.getPlayerDataContainer(player);
    	playerDataContainer.addBlockChange(block);
    	
    	//for the block database
    	String username = CoreAPI.getPlayerName(player);
    	Block oldBlock = event.getBlock();
    	Location location = CoreAPI.getBlockLocation(oldBlock);
    	int block_id1 = CoreAPI.getBlockType(oldBlock).getId();
    	byte block_data1 = CoreAPI.getBlockData(oldBlock);
    	int block_id2 = CoreAPI.getId(Material.AIR);
    	byte block_data2 = (byte) 0;
    	recordBlockChange(username, location, block_id1, block_data1, block_id2, block_data2);
    }
}
