package me.ntfwc.blockLoggingPlugin;

import java.util.Queue;
import java.util.concurrent.ConcurrentLinkedQueue;

public abstract class BlockTaskQueuing {
	private static Queue<BlockTask> taskQueue = new ConcurrentLinkedQueue<BlockTask>();
	
	public static void addTask(BlockTask task)
	{
		taskQueue.add(task);
	}
	
	public static void runTasks(int maxTasks)
	{
		int tasksRun = 0;
		while (tasksRun < maxTasks)
		{
			BlockTask task = taskQueue.poll();
			if (task == null) break;
			
			task.run();
			
			tasksRun++;
		}
	}
	
}
