package me.ntfwc.blockLoggingPlugin;

import java.util.Date;

import org.bukkit.World;

public class LoggableBlockChange implements Comparable<LoggableBlockChange>
{
	int x;
	int y;
	int z;
	String username;
	String worldName;
	int block_id1;
	byte block_data1;
	int block_id2;
	byte block_data2;
	long time;
	public LoggableBlockChange(int x, int y, int z, String username, String worldName, int block_id1, byte block_data1, int block_id2, byte block_data2, long time)
	{
		this.x = x;
		this.y = y;
		this.z = z;
		this.username = username.toLowerCase();
		this.worldName = worldName;
		this.block_id1 = block_id1;
		this.block_data1 = block_data1;
		this.block_id2 = block_id2;
		this.block_data2 = block_data2;
		this.time = time;
	}
	
	public int compareTo(LoggableBlockChange other)
	{
		if (this.time > other.time)
		{
			return 1;
		}
		else if (this.time < other.time)
		{
			return -1;
		}
		else
		{
			return 0;
		}
	}
	
	private String getDateString(Date date)
	{
		return date.toString();
	}
	
	@Override
	public String toString()
	{
		Date date = new Date(time);
		return username + " " + block_id1 + ":" + block_data1 + " -> " + block_id2 + ":" + block_data2 + " at " + getDateString(date);
	}
	
	public void redo(World world)
	{
		ExtendedBlockMaterial blockMaterial = CoreAPI.getExtendedBlockMaterial(block_id2, block_data2);
		CoreAPI.asyncSetBlockAtLocation(world, x, y, z, blockMaterial);
	}
	
	public void rollback(World world)
	{
		ExtendedBlockMaterial blockMaterial = CoreAPI.getExtendedBlockMaterial(block_id1, block_data1);
		CoreAPI.asyncSetBlockAtLocation(world, x, y, z, blockMaterial);
	}
}