package me.ntfwc.blockLoggingPlugin;

import java.sql.SQLException;
import java.util.LinkedList;

import org.bukkit.Location;
import org.bukkit.entity.Player;

public class LoggingTask_GetChangesForLocation implements LoggingTask{
	private Player player;
	private Location location;
	
	public LoggingTask_GetChangesForLocation(Player player, Location location)
	{
		this.player = player;
		this.location = location;
	}
	
	
	
	private void outputResultToPlayer(LinkedList<LoggableBlockChange> result)
	{
		CoreAPI.asyncSendMessage(player, "--------block log query result---------");
		for (LoggableBlockChange blockChange : result)
		{
			String message = blockChange.toString();
			CoreAPI.asyncSendMessage(player, message);
		}
	}
	
	public void run() throws SQLException
	{
		String worldName = CoreAPI.getWorldName(location);
		int x = CoreAPI.getX(location);
		int y = CoreAPI.getY(location);
		int z = CoreAPI.getZ(location);
		LinkedList<LoggableBlockChange> result = BlockLoggingDatabase.getBlockChangesForLocation(worldName, x, y, z);
		
		outputResultToPlayer(result);
	}
	
}
