package me.ntfwc.blockLoggingPlugin;

import org.bukkit.Location;
import org.bukkit.command.Command;
import org.bukkit.entity.Player;

public abstract class PlayerCommandProcessing {
	public static boolean processPlayerCommand(Player player, Command cmd, String commandLabel, String[] args)
	{
		String commandNameLower = cmd.getName().toLowerCase();
		if (commandNameLower.equals("getblocklog"))
		{
			return commandGetBlockLog(player);
		}
		else if (commandNameLower.equals("rollbackregion"))
		{
			return commandRollbackRegion(player, args);
		}
		else if (commandNameLower.equals("redoregionblockchanges"))
		{
			return commandRedoRegionBlockChanges(player, args);
		}
		CoreAPI.sendMessage(player, "This command is not available to players.");
		return true;
	}
	
	private static boolean commandGetBlockLog(Player player)
	{
		Location location = CoreAPI.getLastBlockEditLocation(player);
		if (location == null)
		{
			CoreAPI.sendMessage(player, "You have not altered a block yet.");
			return true;
		}
		LoggingTask_GetChangesForLocation task = new LoggingTask_GetChangesForLocation(player, location);
		
		CoreAPI.blockLoggingRunnable.enqueTask(task);
		
		return true;
	}
	private static boolean commandRollbackRegion(Player player, String[] args)
	{
		if (args.length == 0)
		{
			return false;
		}
		String username = args[0];
		
		Tuple2<Location,Location> locations = CoreAPI.getLastTwoBlockEditLocations(player);
		Location location1 = locations.getItem1();
		Location location2 = locations.getItem2();
		if (location1 == null || location2 == null || location1.getWorld() != location2.getWorld())
		{
			CoreAPI.sendMessage(player, "You have not altered two blocks yet.");
			return true;
		}
		
		LoggingTask_RollbackRegion task = new LoggingTask_RollbackRegion(username, location1, location2);
		
		CoreAPI.blockLoggingRunnable.enqueTask(task);
		
		return true;
	}
	
	private static boolean commandRedoRegionBlockChanges(Player player, String[] args)
	{
		if (args.length == 0)
		{
			return false;
		}
		String username = args[0];
		
		Tuple2<Location,Location> locations = CoreAPI.getLastTwoBlockEditLocations(player);
		Location location1 = locations.getItem1();
		Location location2 = locations.getItem2();
		if (location1 == null || location2 == null || location1.getWorld() != location2.getWorld())
		{
			CoreAPI.sendMessage(player, "You have not altered two blocks yet.");
			return true;
		}
		
		LoggingTask_RedoRegionChanges task = new LoggingTask_RedoRegionChanges(username, location1, location2);
		
		CoreAPI.blockLoggingRunnable.enqueTask(task);
		
		return true;
	}
	
}
